# Buildkite Resource Provider

[![](https://img.shields.io/github/license/muhlba91/pulumi-buildkite?style=for-the-badge)](LICENSE)
[![](https://img.shields.io/github/actions/workflow/status/muhlba91/pulumi-buildkite/verify.yml?style=for-the-badge)](https://github.com/muhlba91/pulumi-buildkite/actions/workflows/verify.yml)
[![](https://img.shields.io/github/release-date/muhlba91/pulumi-buildkite?style=for-the-badge)](https://github.com/muhlba91/pulumi-buildkite/releases)
[![](https://img.shields.io/pypi/v/pulumi-buildkite?style=for-the-badge)](https://pypi.org/project/pulumi-buildkite/)
[![](https://img.shields.io/pypi/dm/pulumi-buildkite?style=for-the-badge)](https://pypi.org/project/pulumi-buildkite/)
[![](https://img.shields.io/nuget/v/Pulumi.Buildkite?style=for-the-badge)](https://www.nuget.org/packages/Pulumi.Buildkite/)
[![](https://img.shields.io/nuget/dt/Pulumi.Buildkite?style=for-the-badge)](https://www.nuget.org/packages/Pulumi.Buildkite/)
[![](https://img.shields.io/npm/v/@muhlba91/pulumi-buildkite?style=for-the-badge)](https://www.npmjs.com/package/@muhlba91/pulumi-buildkite)
[![](https://img.shields.io/npm/dm/@muhlba91/pulumi-buildkite?style=for-the-badge)](https://www.npmjs.com/package/@muhlba91/pulumi-buildkite)
[![](https://img.shields.io/github/all-contributors/muhlba91/pulumi-buildkite?color=ee8449&style=for-the-badge)](#contributors)
<a href="https://www.buymeacoffee.com/muhlba91" target="_blank"><img src="https://cdn.buymeacoffee.com/buttons/default-orange.png" alt="Buy Me A Coffee" height="28" width="150"></a>

The Buildkite Resource Provider lets you manage [Buildkite](http://buildkite.com) resources.

The provider is built on https://github.com/buildkite/terraform-provider-buildkite.

## Installing

This package is available in many languages in the standard packaging formats.

### Installing the Plugin

1. Download the appropriate archive file from the Releases page:
   `wget https://github.com/muhlba91/pulumi-buildkite/releases/download/vX.Y.Z/pulumi-resource-buildkite-vX.Y.Z-OPERATING_SYSTEM-ARCH.tar.gz`
2. Add the plugin to Pulumi:
   `pulumi plugin install resource buildkite X.Y.Z -f ./pulumi-resource-buildkite-vX.Y.Z-OPERATING_SYSTEM-ARCH.tar.gz`

### Node.js (JavaScript/TypeScript)

To use from JavaScript or TypeScript in Node.js, install using either `npm`:

```bash
npm install @muhlba91/pulumi-buildkite
```

or `yarn`:

```bash
yarn add @muhlba91/pulumi-buildkite
```

### Python

To use from Python, install using `pip`:

```bash
pip install pulumi-buildkite-bridge
```

### Go

To use from Go, use `go get` to grab the latest version of the library:

```bash
go get github.com/muhlba91/pulumi-buildkite/sdk/go/...
```

### .NET

To use from .NET, install using `dotnet add package`:

```bash
dotnet add package Pulumi.Buildkite
```

## Configuration

You need to set the following environment variables:

- `BUILDKITE_API_TOKEN`: the API token (required)
- `BUILDKITE_ORGANIZATION`: the organization to create resources in (required)
- `BUILDKITE_GRAPHQL_URL`: the GraphQL URL (optional)
- `BUILDKITE_REST_URL`: the REST URL (optional)

Example for *Typescript* to create a resource:

```typescript
import * as buildkite from '@muhlba91/pulumi-buildkite';

const args = {};
const vm = new buildkite.agent.AgentToken(
  'token',
  args,
);
```

## Reference

For detailed reference documentation, please visit the upstream Terraform provider's documentation at: https://registry.terraform.io/providers/buildkite/buildkite/latest>

## Contributors

Thanks goes to these wonderful people ([emoji key](https://allcontributors.org/docs/en/emoji-key)):

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tbody>
    <tr>
      <td align="center" valign="top" width="14.28%"><a href="https://muehlbachler.io/"><img src="https://avatars.githubusercontent.com/u/653739?v=4?s=100" width="100px;" alt="Daniel Mühlbachler-Pietrzykowski"/><br /><sub><b>Daniel Mühlbachler-Pietrzykowski</b></sub></a><br /><a href="#maintenance-muhlba91" title="Maintenance">🚧</a> <a href="https://github.com/muhlba91/pulumi-buildkite/commits?author=muhlba91" title="Code">💻</a> <a href="https://github.com/muhlba91/pulumi-buildkite/commits?author=muhlba91" title="Documentation">📖</a></td>
    </tr>
  </tbody>
</table>

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->

This project follows the [all-contributors](https://github.com/all-contributors/all-contributors) specification. Contributions of any kind welcome!
